//+------------------------------------------------------------------+
//|                                                           x3.mq5 |
//+------------------------------------------------------------------+
#property description "Component x3"

#define VERSION "1.0"
#property version VERSION

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_plots   1
#property indicator_label1  "x3"
#property indicator_type1   DRAW_COLOR_LINE
#property indicator_color1  clrDarkGray,clrAzure,clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  2

input  int                ep = 14;                    
input  ENUM_APPLIED_PRICE ap = PRICE_CLOSE; 

double b1[],
       b2[]; 

double m_fastEnd,
       m_slowEnd; 
       
int m_period;

//------------------------------------------------------------------
// Custom indicator initialization function
//------------------------------------------------------------------

int OnInit()
{
   SetIndexBuffer(0,b1   ,INDICATOR_DATA);
   SetIndexBuffer(1,b2  ,INDICATOR_COLOR_INDEX);
         m_period    = (ep>1) ? ep : 1;
         m_fastEnd   = MathMax(m_period/2.0,1);
         m_slowEnd   =         m_period*5;

   IndicatorSetString(INDICATOR_SHORTNAME,"Component x3("+(string)m_period+")");
   return(INIT_SUCCEEDED);
}

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
{
   struct _sEF
   {
      double _p;
      double _d;
      double _n;
   };

   static _sEF m_array[];
   static int        m_arraySize=-1;
   
   if (m_arraySize<rates_total) m_arraySize = ArrayResize(m_array,rates_total+500); if (m_arraySize<rates_total) return(0);
  
   int i= prev_calculated-1; if (i<0) i=0; for (; i<rates_total && !_StopFlag; i++)
   {
      switch(ap)
      {
         case PRICE_CLOSE:    m_array[i]._p = close[i];                               break;
         case PRICE_OPEN:     m_array[i]._p = open[i];                                break;
         case PRICE_HIGH:     m_array[i]._p = high[i];                                break;
         case PRICE_LOW:      m_array[i]._p = low[i];                                 break;
         case PRICE_MEDIAN:   m_array[i]._p = (high[i]+low[i])/2.0;                   break;
         case PRICE_TYPICAL:  m_array[i]._p = (high[i]+low[i]+close[i])/3.0;          break;
         case PRICE_WEIGHTED: m_array[i]._p = (high[i]+low[i]+close[i]+close[i])/4.0; break;
         default : m_array[i]._p = 0; 
      }
            
      m_array[i]._d = (i>0) ? m_array[i]._p-m_array[i-1]._p : 0; 
      if (m_array[i]._d<0) m_array[i]._d *= -1.0;

      double ___s  = 0;
      
         if (i>m_period)
         {
            ___s  = m_array[i]._p-m_array[i-m_period]._p; 
            if (___s<0) ___s *= -1.0;
            m_array[i]._n = m_array[i-1]._n + m_array[i]._d - m_array[i-m_period]._d;
         }         
         else       
         {
            m_array[i]._n = m_array[i]._d;
            for(int k=1; k<m_period && i>=k; k++) {
               m_array[i]._n += m_array[i-k]._d;
            }                        
         }
      
      double __r       = (m_array[i]._n!=0) ? ___s/m_array[i]._n : 1;
      double __rap = (m_array[i]._n!=0) ? ((___s/m_array[i]._n)*(m_slowEnd-m_fastEnd))+m_fastEnd : m_period;
      b1[i]  = (i>0) ? b1[i-1]+(2.0/(1.0+__rap))*(m_array[i]._p -b1[i-1]) : (m_array[i]._p);
      b2[i] = (i>0) ? b1[i]>b1[i-1] ? 1 : b1[i]<b1[i-1] ? 2 : b2[i-1] : 0;
   }      
   return(rates_total);
}