//+------------------------------------------------------------------+
//|                                                           x4.mq5 |
//+------------------------------------------------------------------+
#property description "Component x4"

#define VERSION "1.0"
#property version VERSION

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_plots   4

#property indicator_label1  "Line1"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrOrange
#property indicator_style1  STYLE_SOLID
#property indicator_width1  2

#property indicator_label2  "Line2"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrCornflowerBlue
#property indicator_style2  STYLE_SOLID
#property indicator_width2  6

#property indicator_label3  "Line3"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrSilver
#property indicator_style3  STYLE_SOLID
#property indicator_width3  2

#property indicator_label4  "Line4"
#property indicator_type4   DRAW_LINE
#property indicator_color4  clrOrangeRed
#property indicator_style4  STYLE_SOLID
#property indicator_width4  3

input        int lp         = 2;
input        int lev        = 132;
input        double mpl     = -2.0;
input        int lsf        = 0;
input        int itv        = 3;
input        int spp        = 400;

double b1[];
double b2[];
double b3[];
double b4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   SetIndexBuffer(0,b1,INDICATOR_DATA);
   SetIndexBuffer(1,b2,INDICATOR_DATA);
   SetIndexBuffer(2,b3,INDICATOR_DATA);
   SetIndexBuffer(3,b4,INDICATOR_DATA);

//----
   PlotIndexSetInteger(0,PLOT_SHIFT,119*itv);
   PlotIndexSetInteger(1,PLOT_SHIFT,-72*itv);
   PlotIndexSetInteger(2,PLOT_SHIFT,120*itv);
   PlotIndexSetInteger(3,PLOT_SHIFT,lsf*itv);
//----

   ArraySetAsSeries(b4,true);
   ArraySetAsSeries(b3,true);
   ArraySetAsSeries(b2,true);
   ArraySetAsSeries(b1,true);

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int i,z,limit;
   ArraySetAsSeries(open,true);
   if(prev_calculated==0)
     {
      limit=rates_total-spp*itv;
      if(limit<1)return(0);
      for(i=rates_total-1;i>=limit;i--)
        {
         b1[i]=open[limit];
         b2[i]=open[limit];
         b3[i]=open[limit];
         b4[i]=open[limit];
        }
     }
   else limit=rates_total-prev_calculated;
   for(i=limit;i>=0 && !IsStopped();i--)
     {
      b2[i]=((open[i])+5061600*b2[i+1*itv]-7489800*b2[i+2*itv]+4926624*b2[i+3*itv]-1215450*b2[i+4*itv])/1282975;

      if(lp==2) 
        {
         b3[i+192*itv]=b2[i];
         if(i>=0) for(z=192-1;z>=0;z--) b3[i+0+z*itv]=2.998096443*b3[i+1*itv+z*itv]-2.9980964433*b3[i+2*itv+z*itv]+1*b3[i+3*itv+z*itv];
         b1[i+192*itv]=(b3[i+193*itv]-1.998096443*b3[i+192*itv]+b3[i+191*itv])/0.001903557;
         if(i>=0) for(z=192-1;z>=0;z--) b1[i+0+z*itv]=(b3[i+2*itv+z*itv]-1.998096443*b3[i+1*itv+z*itv]+b3[i+0*itv+z*itv])/0.001903557;
        }

      if(lp==3) 
        {
         b3[i+192*itv]=b2[i];
         if(i>=0) for(z=192-1;z>=0;z--) b3[i+0+z*itv]=3.998096443*b3[i+1*itv+z*itv]-5.996192886*b3[i+2*itv+z*itv]+3.998096443*b3[i+3*itv+z*itv]-1*b3[i+4*itv+z*itv];
         b1[i+192*itv]=(b3[i+193*itv]-1.998096443*b3[i+192*itv]+b3[i+191*itv])/0.001903557;
         if(i>=0) for(z=192-1;z>=0;z--) b1[i+0+z*itv]=(b3[i+2*itv+z*itv]-1.998096443*b3[i+1*itv+z*itv]+b3[i+0*itv+z*itv])/0.001903557;
        }

      if(lp==4) 
        {
         b3[i+192*itv]=b2[i];
         if(i>=0) for(z=192-1;z>=0;z--) b3[i+0+z*itv]=4.998096443*b3[i+1*itv+z*itv]-9.994289329*b3[i+2*itv+z*itv]+9.994289329*b3[i+3*itv+z*itv]-4.998096443*b3[i+4*itv+z*itv]+1*b3[i+5*itv+z*itv];

         b1[i+192*itv]=(b3[i+193*itv]-1.998096443*b3[i+192*itv]+b3[i+191*itv])/0.001903557;
         if(i>=0) for(z=192-1;z>=0;z--) b1[i+0+z*itv]=(b3[i+2*itv+z*itv]-1.998096443*b3[i+1*itv+z*itv]+b3[i+0*itv+z*itv])/0.001903557;

         b4[i]=(b3[i+192*itv-lev*itv]-b1[i+192*itv-lev*itv]) *mpl+b1[i+192*itv-lev*itv];
        }
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+
